<?php
global $wpdb;

define('GD_WIDGETS', TEMPLATEPATH . '/inc/widgets/');
require(  get_template_directory() . '/inc/theme-settings.php');                //Building theme administration

require(  get_template_directory() . '/inc/meta-boxes.php');                    //Building meta boxes

require(  get_template_directory() . '/inc/custom-taxonomies.php');             //Building post types

$lang = get_template_directory() . '/languages/';                               //Make this theme available for translation.
load_theme_textdomain('tint', $lang);

add_theme_support( 'automatic-feed-links' );                                    //Add default posts and comments RSS feed links to <head>

add_theme_support( 'post-thumbnails' );                                         //This enables Post Thumbnails support for this theme.
        add_image_size( 'slider', 980, 9999);
        add_image_size( 'portfolio', 220 , 195 , true );
        add_image_size( 'home_portfolio', 343 , 150 , true );
        add_image_size( 'blog', 489 , 204 , true );
        add_image_size( 'single', 685 , 327 , true );

register_nav_menu( 'primary', __( 'Primary Menu', 'tint' ) );                //This theme uses wp_nav_menu()



function new_excerpt_more($more) {
	return '...';
}
add_filter('excerpt_more', 'new_excerpt_more');


function tk_theme_name(){
    $theme = wp_get_theme();
    return $theme->name;
}
define( 'tk_theme_name', 'Booker' );
update_option('tk_theme_name', tk_theme_name);

$tk_theme_name = 'Booker';



        /*************************************************************/
        /************INCREASE IMAGE QUALITY*****************/
        /************************************************************/

            function jpeg_quality_callback($arg)
            {
            return (int)100;
            }

            add_filter('jpeg_quality', 'jpeg_quality_callback');



        /*************************************************************/
        /************GET URL OF CURENT PAGE*****************/
        /************************************************************/

function get_page_url(){

	$pageURL = 'http';
	if (isset($_SERVER["HTTPS"])) {$pageURL .= "s";}
	$pageURL .= "://";
	if ($_SERVER["SERVER_PORT"] != "80") {
		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	} else {
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	}
	return $pageURL;

}




        
        /*************************************************************/
        /************SAVE ID AND TITLE OF PAGE TEMPLATES*********/
        /************************************************************/

   add_action ( 'publish_page', 'saveBlogId' );

   function saveBlogId($post_ID)  {
   	global $wp_query;
       $blog_title =  get_the_title($post_ID);
  $template_name = get_post_meta( $post_ID, '_wp_page_template', true );
 if($template_name == "_blog.php"){
     update_option('id_blog_page',$post_ID);
     update_option('title_blog_page',$blog_title);
 }

   $oldblog = get_option('id_blog_page');
   	if($post_ID == $oldblog){
   		  if($template_name <> "_blog.php"){
   		  		update_option('id_blog_page','');
   		  }
   	}
   }




        /*************************************************************/
        /************MAINTENANCE MODE****************************/
        /*************************************************************/

$options = get_option('maintenance_mode_maintenance');


if ( $options[0] == 'on' ) { add_action('get_header', 'activate_maintenance_mode'); }

function activate_maintenance_mode() {                                          //Maintenance mode

    if ( !(current_user_can( 'administrator' ) ||  current_user_can( 'super admin' ))) {

        wp_die('<h1>Website Under Maintenance</h1><p>Hi, our Website is currently undergoing scheduled maintenance.
        Please check back very soon.<br /><strong>Sorry for the inconvenience!</strong></p>', 'Maintenance Mode');
    }
}




        /*************************************************************/
        /************LOAD SHORTCODES******************************/
        /*************************************************************/



function enable_more_buttons($buttons) {
  $buttons[] = 'hr';

  return $buttons;
}
add_filter("mce_buttons", "enable_more_buttons");

function shortcode_one_half( $atts, $content = null ) {
    	extract(shortcode_atts(array(
		'position'     	 => '',
    ), $atts));

   return '<div class="one-half '.$position.'">' . do_shortcode($content) . '</div>';
}

add_shortcode('one_half', 'shortcode_one_half');

function shortcode_one_third( $atts, $content = null ) {
    	extract(shortcode_atts(array(
		'position'     	 => '',
    ), $atts));
        
   return '<div class="one-third '.$position.'">' . do_shortcode($content) . '</div>';
}

add_shortcode('one_third', 'shortcode_one_third');

function shortcode_one_fourth( $atts, $content = null ) {
    	extract(shortcode_atts(array(
		'position'     	 => '',
    ), $atts));
        
   return '<div class="one-fourth '.$position.'">' . do_shortcode($content) . '</div>';
}

add_shortcode('one_fourth', 'shortcode_one_fourth');


function shortcode_button( $atts, $content = null ) {

	extract(shortcode_atts(array(
		'url'     	 => '#',
		'target'     => '_self',
		'style'   => 'orange',
    ), $atts));

   return '<div class="color-buttons color-button-'.$style.' left"><a href="'.$url.'">' . do_shortcode($content) . '</a></div>';
}

add_shortcode('button', 'shortcode_button');



 
include("update_notifier.php");



 
 
 
 //PayPal notification
if(@$_GET['paperbook'] == '1'){
	paperbook();       
}
 
 
 
 
 
//PayPal notification
if(@$_GET['paypal'] == '1'){
	paypal_notification();       
}
if(@$_GET['download-file'] != ''){
    download_file();
}

function paypal_notification(){
global $wpdb;
$sandbox = $_POST['test_ipn'];

foreach ($_POST as $key => $value) {
$value = urlencode(stripslashes($value));
$req .= "&$key=$value";
}

// assign posted variables to local variables
$txn_id = $_POST['txn_id'];
$item_name = $_POST['item_name'];
$payment_status = $_POST['payment_status'];
$payment_amount = $_POST['mc_gross'];
$payment_currency = $_POST['mc_currency'];
$payer_email = $_POST['payer_email'];
$first_name = $_POST['first_name'];
$last_name = $_POST['last_name'];
$custom = $_POST['custom'];
$payment_date = $_POST['payment_date'];
$test_ipn = $_POST['test_ipn'];
$valid_days = get_option(tk_theme_name.'_storesettings_link_valid');

if($valid_days == ''){
    $valid_days = '1';
}

$todayDate = date("Y-m-d H:i:s");
$date = strtotime(date("Y-m-d H:i:s", strtotime($todayDate)) . " +".$valid_days." day");
$valid_link_date = date('Y-m-d H:i:s',$date);

$table_name = $wpdb->prefix . "paypal_transactions";
$wpdb->query('INSERT INTO '.$table_name.'
    (txn_id, payment_date, payment_status, mc_currency, mc_gross, first_name, last_name, payer_email, custom, downloaded, valid_date, test_ipn)
    VALUES ("'.$txn_id.'",
            "'.$payment_date.'",
            "'.$payment_status.'",
            "'.$payment_currency.'",
             '.$payment_amount.',
            "'.$first_name.'",
            "'.$last_name.'",
            "'.$payer_email.'",
            "'.$custom.'",
             "0",
            "'.$valid_link_date.'",
            "'.$test_ipn.'"
)');

$download_link = get_bloginfo('url').'/?download-file='.$custom;

$message = get_option(tk_theme_name.'_storesettings_email_message');
$mail_template_from = array('[FIRST_NAME]','[LAST_NAME]','[PRODUCT_NAME]','[DOWNLOAD LINK]','[TRANSACTION_ID]','[LINK_VALID]');
$mail_template_to = array($first_name, $last_name, $item_name, $download_link, $txn_id, get_option(tk_theme_name.'_storesettings_link_valid').' days', ) ;

$message = str_replace($mail_template_from, $mail_template_to, $message);

$email_headers = 'From: '.get_option('blogname').' <'.get_option('admin_email').'>' . "\r\n";
wp_mail( $payer_email, 'Download link', $message, $email_headers);

//mail('marko.ic@gmail.com', 'Download link', $message, $email_headers);
// check the payment_status is Completed
// check that txn_id has not been previously processed
// check that receiver_email is your Primary PayPal email
// check that payment_amount/payment_currency are correct
// process payment
//}
//}
}







function paperbook(){
global $wpdb;
$sandbox = $_POST['test_ipn'];

foreach ($_POST as $key => $value) {
$value = urlencode(stripslashes($value));
$req .= "&$key=$value";
}

// assign posted variables to local variables
$txn_id = $_POST['txn_id'];
$item_name = $_POST['item_name'];
$payment_status = $_POST['payment_status'];
$payment_amount = $_POST['mc_gross'];
$payment_currency = $_POST['mc_currency'];
$payer_email = $_POST['payer_email'];
$first_name = $_POST['first_name'];
$last_name = $_POST['last_name'];
$custom = $_POST['custom'];
$payment_date = $_POST['payment_date'];
$test_ipn = $_POST['test_ipn'];
$valid_days = get_option(tk_theme_name().'_storesettings_link_valid');

if($valid_days == ''){
    $valid_days = '1';
}

$todayDate = date("Y-m-d H:i:s");
$date = strtotime(date("Y-m-d H:i:s", strtotime($todayDate)) . " +".$valid_days." day");
$valid_link_date = date('Y-m-d H:i:s',$date);

$table_name = $wpdb->prefix . "paypal_transactions";
$wpdb->query('INSERT INTO '.$table_name.'
    (txn_id, payment_date, payment_status, mc_currency, mc_gross, first_name, last_name, payer_email, custom, downloaded, valid_date, test_ipn)
    VALUES ("'.$txn_id.'",
            "'.$payment_date.'",
            "'.$payment_status.'",
            "'.$payment_currency.'",
             '.$payment_amount.',
            "'.$first_name.'",
            "'.$last_name.'",
            "'.$payer_email.'",
            "'.$custom.'",
             "0",
            "'.$valid_link_date.'",
            "'.$test_ipn.'"
)');


$message = get_option(tk_theme_name().'_storesettings_email_message_paper');
$mail_template_from = array('[FIRST_NAME]','[LAST_NAME]','[PRODUCT_NAME]','[TRANSACTION_ID]');
$mail_template_to = array($first_name, $last_name, $item_name, $txn_id ) ;

$message = str_replace($mail_template_from, $mail_template_to, $message);

$email_headers = 'From: '.get_option('blogname').' <'.get_option('admin_email').'>' . "\r\n";
wp_mail( $payer_email, 'Product Information', $message, $email_headers);

}






function download_file(){
global $wpdb;
//echo $_GET['download-file'];
$testipn = get_option(tk_theme_name().'_storesettings_paypal_sandbox');

$table_name = $wpdb->prefix . "paypal_transactions";
$querystr = "SELECT * FROM " . $table_name . " WHERE custom = '".mysql_real_escape_string(@$_GET['download-file'])."' AND test_ipn = '$testipn[0];' AND valid_date >= NOW()";
$result = $wpdb->get_results($querystr,ARRAY_A);
$id = @$result[0]['id'];
    if($id != ''){
        $updateDownloads = "UPDATE " . $wpdb->prefix . "paypal_transactions SET downloaded = (downloaded + 1) WHERE custom = '".mysql_real_escape_string(@$_GET['download-file'])."'";
        $wpdb->query( $updateDownloads );

        $download_url = get_option(tk_theme_name().'_storesettings_download_path');
        header('Content-disposition: attachment; filename=' . basename($download_url));
	header('Content-Type: application/octet-stream');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Expires: 0');
	$result = wp_remote_get($download_url);
  
	echo $result['body'];
	die();
    }    
}
?>
<?php
if ( is_admin() && isset($_GET['activated'] ) && $pagenow == "themes.php" ) {
    appos_install();
}
function appos_install() {
   global $wpdb;
   $table_name = $wpdb->prefix . "paypal_transactions";
   $sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique ID',
  `txn_id` varchar(40) COLLATE utf8_unicode_ci NOT NULL COMMENT 'PayPal transaction ID',
  `payment_date` varchar(15) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Payment date received by PayPal',
  `payment_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `mc_currency` varchar(5) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Currency (EUR, USD, etc.)',
  `mc_gross` float NOT NULL COMMENT 'Product gross price',
  `first_name` varchar(20) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Payer first name',
  `last_name` varchar(20) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Payer last name',
  `payer_email` text COLLATE utf8_unicode_ci NOT NULL,
  `custom` varchar(32) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Security code',
  `downloaded` int(11) NOT NULL COMMENT 'How many times payer downloaded product',
  `valid_date` datetime NOT NULL COMMENT 'Validation date of link sent to payer',
  `test_ipn` tinyint(4) NOT NULL COMMENT 'Is it Sendbox? 1 = (test purchase), 0 = no (real purchase)',
  PRIMARY KEY (`id`)
) CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1;";

   require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
   if(dbDelta($sql)){
       //TABLE CREATED!
   }else{
       //TABLE ISN'T CREATED
   }
}


 function remove_wp_magic_quotes()
    {
        $_GET    = stripslashes_deep($_GET);
        $_POST   = stripslashes_deep($_POST);
        $_COOKIE = stripslashes_deep($_COOKIE);
        $_REQUEST = stripslashes_deep($_REQUEST);
    }

    remove_wp_magic_quotes();

 
 ?>